<?php
class cartoons
{
	public $toons;

	function add_toons($dir)
	{
		$toondirid = @opendir($dir);

		if ($toondirid != false) {
			while (($file = @readdir($toondirid)) != false) {
				/* Only process files, skip directories. */
				if (is_file($dir.$file) == false)
					continue;

				$cartoon = new cartoon;

				if ($cartoon->add_toon($dir.$file) == false) {
					closedir($toondirid);
					return false;
				}

				$time = filemtime($dir.$file);
				if ($time == false) {
					closedir($toondirid);
					return false;
				}

				$cartoon->add_time($time);
				$this->toons[] = $cartoon;
			}
		} else {
			return false;
		}

		closedir($toondirid);

		return true;
	}

	function sort_toons()
	{
		$num_toons = count($this->toons);

		for ($i = 0; $i < $num_toons; $i++) {
			$index = $this->toons[$i];
			$j = $i;

			while ($j > 0 && $list[$j - 1]->time > $index->time )
			{
				$list[$j] = $list[$j - 1];
				--$j;
			}

			$list[$j] = $index;
		}

		for ($i = 0; $i < $num_toons; $i++)
			$this->toons[$i] = $list[$num_toons - $i - 1];
	}

	function print_toons()
	{
		for($i = 0; $i < count($this->toons); $i++)
			$this->toons[$i]->print_toon();
		return true;
	}
}

class cartoon
{
	public $width;
	public $height;
	public $img_type;
	public $img_attr;
	public $path;
	public $name;
	public $time = 0;

	function add_toon($path)
	{
		if (!is_file($path))
			return false;

		if (strrpos($path, '/'))
			$this->name = substr($path, strrpos($path, '/') + 1);
		else
			return false;

		$this->path = $path;

		list($width, $height, $img_type, $img_attr) =
			@getimagesize($path);

		if ($width <= 0)
			return false;

		$this->width = $width;
		$this->height = $height;
		$this->img_type = $img_type;
		$this->img_attr = $img_attr;

		return true;
	}

	function add_time($time)
	{
		$this->time = $time;
	}

	function print_toon()
	{
		if ($this->width <= 0)
			return;

		echo "<div>\n";
		echo "<a name=\"".$this->name."\"></a>\n";
		echo "<p>";
		if (abs(time() - $this->time) < 60 * 60 * 2)
			echo "<span class=\"ok\">New </span>";
		echo "(<a href=\"/".$this->path."\">".$this->name."</a>) ";
		echo "[<a href=\"#".$this->name."\">direct</a>]";
		if ($this->time > 0)
			echo " (downloaded ".date("Y-m-d G:i:s", $this->time).")";
		if (abs(time() - $this->time) < 60 * 60 * 2)
			echo "<span class=\"ok\"> New</span>";
		echo "</p>\n";
		echo "<a href=\"/".$this->path."\">\n";
		echo "<img src=\"/".$this->path."\" width=\"".$this->width."\" "
			."height=\"".$this->height."\" alt=\"".$this->name."\">"
			."</img>\n";
		echo "</a>\n";
		echo "</div>\n";
	}
}
?>
